import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { is, fromJS } from 'immutable'
import {
  Player,
  ControlBar,
  CurrentTimeDisplay,
  TimeDivider,
  BigPlayButton,
  PlaybackRateMenuButton,
  VolumeMenuButton
} from 'video-react'

import './index.scss'

class Video extends Component {
  static propTpyes = {
    poster: PropTypes.string,
    card: PropTypes.object,
    value: PropTypes.any,
  }

  shouldComponentUpdate (nextProps, nextState) {
    return !is(fromJS(this.props), fromJS(nextProps))
  }

  render() {
    const { value, card, poster } = this.props

    return (
      <div style={{overflow: 'hidden'}}>
        <Player startTime={card.startTime || 0} poster={poster || ''} currentTime={10} autoPlay={card.autoPlay === 'true'} aspectRatio={card.aspectRatio || '16:9'} loop={card.loop === 'true'}>
          <source src={value} />
          <BigPlayButton position="center" />
          <ControlBar>
            <VolumeMenuButton />
            <CurrentTimeDisplay />
            <TimeDivider />
            <PlaybackRateMenuButton rates={[5, 2, 1, 0.5, 0.1]} order={7.1} />
          </ControlBar>
        </Player>
      </div>
    )
  }
}

export default Video